/**
 * 
 */
package sim.loader;

import sim.loader.SLoaderException;

/**
 * L'interface <b>SStringLoader</b> reprsentant un constructeur d'objet (<i>loader</i>) prenant en paramtre un String.
 * Le String peut avoir plusieurs interprtation comme le nom d'un fichier, un mot cl ou une ligne dans un fichier.
 * L'objet qui implmentera cette classe devra spcifier l'interprtation du String afin d'utiliser cette information judicieusement.
 * 
 * @author Simon Vzina
 * @since 2015-03-16
 * @version 2015-04-03
 */
public interface SStringLoader {

  /**
   * Mthode qui fait la construction d'un objet dont le type dpendera de la classe implmentant l'interface SStringLoader.
   *
   * @param file_name Les informations sous forme String permettant au loader de fonctionner.
   * @return L'objet construit par le loader.
   * @throws SLoaderException S'il y a eu une erreur durant le chargement du fichier.
   */
  public Object load(String file_name) throws SLoaderException;
  
}//fin Interface SStringLoader
