/**
 * 
 */
package sim.util;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/**
 * La classe <b>SReader</b> reprsente un lecteur de fichier texte dans le but de charger des informations dans un objet 
 * implmentant l'interface <b>SReadable</b>.
 * 
 * @author Simon Vzina
 * @since 2018-01-16
 * @version 2018-01-16
 */
public class SReader {

  /**
   * Constructeur d'un lecteur. 
   */
  public SReader()
  {
    
  }

  /**
   * Mthode permettant de faire l'affectation d'information dans un objet  l'aide de la lecture d'un fichier texte.
   * 
   * @param file_name Le nom du fichier en lecture.
   * @param obj L'objet qui sera charg en information.
   * @throws FileNotFoundException Si le fichier en lecture n'a pas t trouv.
   * @throws SInitializationException Si une erreur d'initialisation est survenue lors de la lecture.
   * @throws IOException Si une erreur de type I/O est survenue lors de la lecture.
   */
  public void read(String file_name, SReadable obj) throws FileNotFoundException, SInitializationException, IOException
  {
    // Trouver le fichier  partir du rpertoire o l'excution de l'application est ralise
    SFileSearch search = new SFileSearch("", file_name);
    
    if(!search.isFileFound())
      throw new FileNotFoundException("Erreur SReader 001 - Le fichier '" + file_name + "' n'est pas trouv.");
    
    if(search.isManyFileFound())
      throw new SInitializationException("Erreur SReader 002 - Le fichier '" + file_name + "' a t trouv plus d'une fois dans les diffrents sous-rpertoires. Veuillez en garder qu'une seule version.");
    
    // Lecture de la scne  partir d'un fichier
    FileReader fr = new FileReader(search.getFileFoundList().get(0));
    SBufferedReader sbr = new SBufferedReader(fr);
    
    obj.read(sbr);
   
    sbr.close();
    fr.close();
  }
  
}// fin de la classe SReader
